import React,{useEffect} from "react";
import { useSidebar, useThemeStore } from "@/store";
import { cn } from "@/lib/utils";
import { Icon } from "@iconify/react";
import { Search } from "lucide-react";
import { useTranslations } from "next-intl";
import { SiteLogo } from "@/components/svg";
import Link from "next/link";
import './my.css'
import { useMediaQuery } from "@/hooks/use-media-query";

const MenuBar = ({ collapsed, setCollapsed, showText, setShowText }) => {




  return (
    <button
      className={`relative group  disabled:cursor-not-allowed opacity-50`}
      onClick={() => {
        // setCollapsed(!collapsed)
        setShowText(!showText)
        console.log("hamcollapsed------>", collapsed, "hamshowText------->", showText)
      }}
    >
      {/* <div className="hover:bg-[#846CF9]  p-1 rounded-full"> */}
      <div  >

        <div
          className={cn(
            "flex flex-col justify-between w-[20px] h-[16px] transform transition-all duration-300 origin-center overflow-hidden",
            // {
            //   "-translate-x-1.5 rotate-180": collapsed,
            // }
          )}
        >
          <div
            className={cn(
              "bg-card-foreground h-[2px] transform transition-all duration-300 origin-left delay-150",
              // {
              //   "rotate-[42deg] w-[11px]": collapsed,
              //   "w-7": !collapsed,
              // }
            )}
          ></div>
          <div
            className={cn(
              "bg-card-foreground h-[2px] w-7 rounded transform transition-all duration-300",
              // {
              //   "translate-x-10": collapsed,
              // }
            )}
          ></div>
          <div
            className={cn(
              "bg-card-foreground h-[2px] transform transition-all duration-300 origin-left delay-150",
              // {
              //   "-rotate-[43deg] w-[11px]": collapsed,
              //   "w-7": !collapsed,
              // }
            )}
          ></div>
        </div>
      </div>
    </button>
  );
};

const VerticalHeader = ({ handleOpenSearch, userDetailsData }) => {

  const now = new Date();
  const hours = now.getHours();

  var GoodMessage = '';

  if (hours < 12) {
      GoodMessage = "Good Morning";
  } else if (hours >= 12 && hours < 18) {
      GoodMessage = "Good Afternoon";
  } else if (hours >= 18 && hours < 22) {
      GoodMessage = "Good Evening";
  } else {
      GoodMessage = "Good Night";
  }

  const lang = useTranslations("Index");
  const { collapsed, setCollapsed, subMenu, sidebarType, showText, setShowText } = useSidebar();
  const { layout } = useThemeStore();
  const isDesktop = useMediaQuery("(min-width: 1280px)");
  const isMobile = useMediaQuery("(min-width: 768px)");
  let LogoContent = null;
  let menuBarContent = null;
  let WalletsContent = null;

  useEffect(() => {

    const sidebarStore = typeof window !== "undefined" ? JSON.parse(localStorage.getItem("sidebar-store")) : null;
    if(sidebarStore){
      // console.log(sidebarStore?.state.showText)
      // alert(sidebarStore?.state?.showText);
      setShowText(sidebarStore?.state?.showText);
    }
    
    
  }, []);

  // menu bar content condition
  if (isDesktop && sidebarType !== "module") {
    menuBarContent = (
      <MenuBar collapsed={collapsed} setCollapsed={setCollapsed} showText={showText} setShowText={setShowText} />
    );
  }
  if (sidebarType === "module") {
    menuBarContent = (
      <MenuBar collapsed={collapsed} setCollapsed={setCollapsed} showText={showText} setShowText={setShowText} />
    );
  }
  if (sidebarType === "classic") {
    menuBarContent = null;
  }
  if (subMenu && isDesktop) {
    <MenuBar collapsed={collapsed} setCollapsed={setCollapsed} showText={showText} setShowText={setShowText} />
  }

  const MainLogo = (
    <Link href="/dashboard" className=" text-primary ">
      {/* <SiteLogo className="h-7 w-7" /> */}
    </Link>
  );
  if (
    layout === "vertical" &&
    !isDesktop &&
    isMobile &&
    sidebarType === "module"
  ) {
    LogoContent = MainLogo;
  }
  if (layout === "vertical" && !isDesktop && sidebarType !== "module") {
    LogoContent = MainLogo;
  }
  const Wallets = (
    <div id="my-div" className="flex justify-end !ml-0">
      <span className=" md:inline">Hello, {userDetailsData?.first_name} {userDetailsData?.last_name}</span>&nbsp;&nbsp;&nbsp;&nbsp;
      <span className=" md:inline">{GoodMessage}</span>&nbsp;&nbsp;
      {/* <span className="flex items-center space-x-1">
        <span>₹</span>
        <span>{userDetailsData?.wallet ?? '0.00'}</span>
      </span> */}
    </div>



  );


  // menu bar content conditio
  return (
    <>
      <div className="flex items-center md:gap-6 gap-3">
        {LogoContent}
        {menuBarContent}
        {Wallets}
      </div>
    </>
  );
};

export default VerticalHeader;
